/// <reference types="node" />
import EventEmitter from 'events';
import { TJsonValue } from 'typeon';
import Browser from './Browser';
import { TSend } from '../protocol';
import Element from './Element';
declare type TStringifiableFunction = (...args: TJsonValue[]) => TJsonValue | Promise<TJsonValue> | void;
declare class Page extends EventEmitter {
    private _browser;
    private _id;
    private _send;
    constructor(arg: {
        browser: Browser;
        id: number;
        send: TSend;
    });
    $(selector: string): Promise<Element>;
    $$(selector: string): Promise<Element[]>;
    bringToFront(): Promise<import("typeon").TJsonArray | import("typeon").TJsonMap>;
    browser(): Browser;
    close(): Promise<void>;
    content(): Promise<string>;
    evaluate(target: TStringifiableFunction | string, ...args: TJsonValue[]): Promise<TJsonValue | void>;
    focus(selector: string): Promise<string | number | boolean | void | import("typeon").TJsonArray | import("typeon").TJsonMap>;
    goto(url: string): Promise<void>;
    screenshot(options?: {
        path?: string;
    }): Promise<Buffer>;
    setContent(html: string): Promise<import("typeon").TJsonArray | import("typeon").TJsonMap>;
    setViewport({ width, height }: {
        width: number;
        height: number;
    }): Promise<void>;
    title(): Promise<string>;
    url(): Promise<string>;
    viewport(): Promise<{
        width: number;
        height: number;
    }>;
}
export default Page;
